"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.delegateStakingV1 = exports.getDelegateStakingV1InstructionDataSerializer = void 0;
const mpl_essentials_1 = require("@metaplex-foundation/mpl-essentials");
const umi_1 = require("@metaplex-foundation/umi");
const hooked_1 = require("../../hooked");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getDelegateStakingV1InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['delegateStakingV1Discriminator', s.u8()],
        ['amount', s.u64()],
        [
            'authorizationData',
            s.option((0, types_1.getAuthorizationDataSerializer)(context)),
        ],
    ], { description: 'DelegateStakingV1InstructionData' }), (value) => ({
        ...value,
        discriminator: 44,
        delegateStakingV1Discriminator: 5,
        amount: value.amount ?? 1,
        authorizationData: value.authorizationData ?? (0, umi_1.none)(),
    }));
}
exports.getDelegateStakingV1InstructionDataSerializer = getDelegateStakingV1InstructionDataSerializer;
// Instruction.
function delegateStakingV1(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingArgs, 'tokenOwner', input.tokenOwner ?? context.identity.publicKey);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'token', input.token ??
        (0, mpl_essentials_1.findAssociatedTokenPda)(context, {
            mint: (0, umi_1.publicKey)(input.mint),
            owner: resolvingArgs.tokenOwner,
        }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'delegateRecord', input.delegateRecord ??
        (0, accounts_1.findTokenRecordPda)(context, {
            mint: (0, umi_1.publicKey)(input.mint),
            token: (0, umi_1.publicKey)(resolvingAccounts.token),
        }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'metadata', input.metadata ?? (0, accounts_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'masterEdition', input.masterEdition ??
        (0, hooked_1.resolveMasterEdition)(context, { ...input, ...resolvingAccounts }, { ...input, ...resolvingArgs }, programId));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenRecord', input.tokenRecord ??
        (0, hooked_1.resolveTokenRecord)(context, { ...input, ...resolvingAccounts }, { ...input, ...resolvingArgs }, programId));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authority', input.authority ?? context.identity);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'sysvarInstructions', input.sysvarInstructions ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'splTokenProgram', input.splTokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRules', input.authorizationRules ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRulesProgram', input.authorizationRulesProgram ??
        (0, hooked_1.resolveAuthorizationRulesProgram)(context, { ...input, ...resolvingAccounts }, { ...input, ...resolvingArgs }, programId));
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Delegate Record.
    keys.push({
        pubkey: resolvedAccounts.delegateRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.delegateRecord, true),
    });
    // Delegate.
    keys.push({
        pubkey: resolvedAccounts.delegate,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.delegate, false),
    });
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, true),
    });
    // Master Edition.
    keys.push({
        pubkey: resolvedAccounts.masterEdition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.masterEdition, false),
    });
    // Token Record.
    keys.push({
        pubkey: resolvedAccounts.tokenRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenRecord, true),
    });
    // Mint.
    keys.push({
        pubkey: resolvedAccounts.mint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mint, false),
    });
    // Token.
    keys.push({
        pubkey: resolvedAccounts.token,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.token, true),
    });
    // Authority.
    signers.push(resolvedAccounts.authority);
    keys.push({
        pubkey: resolvedAccounts.authority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authority, false),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Sysvar Instructions.
    keys.push({
        pubkey: resolvedAccounts.sysvarInstructions,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.sysvarInstructions, false),
    });
    // Spl Token Program.
    keys.push({
        pubkey: resolvedAccounts.splTokenProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.splTokenProgram, false),
    });
    // Authorization Rules Program.
    keys.push({
        pubkey: resolvedAccounts.authorizationRulesProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRulesProgram, false),
    });
    // Authorization Rules.
    keys.push({
        pubkey: resolvedAccounts.authorizationRules,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRules, false),
    });
    // Data.
    const data = getDelegateStakingV1InstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.delegateStakingV1 = delegateStakingV1;
//# sourceMappingURL=delegateStakingV1.js.map